package com.huimv.acquisition.timmertask;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.huimv.acquisition.entity.*;
import com.huimv.acquisition.mapper.*;
import com.huimv.acquisition.service.BaseFarmInfoService;
import com.huimv.acquisition.service.EartagRegisterService;
import com.huimv.acquisition.service.MovePigpenService;
import com.huimv.acquisition.service.SowRankTableService;
import com.huimv.acquisition.socket.eartagrecive.util.DateUtil;
import com.huimv.acquisition.socket.eartagrecive.util.DateUtilsPublic;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.text.ParseException;
import java.util.Date;
import java.util.List;

import static com.huimv.acquisition.socket.eartagrecive.util.DateUtilsPublic.DATE_FORMAT;

/**
 * @Author Anchor
 * @Date 2021/8/4 15:03
 * @Version 1.0.1
 */

@Slf4j
@Component
public class provideNewRankData {


//将存储的数据更新到最新的排名表--首先列出所有牧场

    @Autowired
    private EartagDataDao eartagDataDao;

    @Autowired
    private BasePigpenDao basePigpenDao;

    @Autowired
    private CollectorRegisterDao collectorRegisterDao;

    @Autowired
    private MovePigpenService movePigpenService;

    @Autowired
    private MovePigpenDao movePigpenDao;
    @Autowired
    private EartagRegisterService eartagRegisterService;

    @Autowired
    private EartagRegisterDao eartagRegisterDao;

    @Autowired
    private BaseFarmInfoDao baseFarmInfoDao;

    @Autowired
    private BaseFarmInfoService baseFarmInfoService;


    @Autowired
    private DailyTabulateDataDao dailyTabulateDataDao;


    @Autowired
    private SowRankTableService sowRankTableService;

    @Autowired
    private SowRankTableDao sowRankTableDao;


    //首先查找出所有的牧场id

    // @Scheduled(cron = "0 0 12 * * ?")
    //@Scheduled(cron = "0/5 * * * * ?")
    private void settingRegisting() throws ParseException {

        String date = DateUtilsPublic.formatDate(new Date(), DATE_FORMAT);
        String datebegan = date + " 00:00:00";
        String dateend = date + " 23:59:00";
        Date datebegan1 = DateUtil.parseDateTime(datebegan);
        Date dateeend = DateUtil.parseDateTime(dateend);

        LambdaQueryWrapper<DailyTabulateDataEntity> lambdaQuery2 = Wrappers.lambdaQuery();
        lambdaQuery2.between(DailyTabulateDataEntity::getStatisticDate, datebegan1, dateeend);
        lambdaQuery2.orderByDesc(DailyTabulateDataEntity::getStockTotal);//母猪总存栏
        List<DailyTabulateDataEntity> dailyTabulateDataEntit = dailyTabulateDataDao.selectList(lambdaQuery2);
        int a = 0;
        System.out.println();
        LambdaQueryWrapper<SowRankTableEntity> lambdaQuery3 = Wrappers.lambdaQuery();
        lambdaQuery3.orderByDesc(SowRankTableEntity::getId).last("limit 1");
        SowRankTableEntity sowRankTableEntity1 = sowRankTableDao.selectOne(lambdaQuery3);

        if (sowRankTableEntity1 == null) {
            //为空，自动执行刷新流程
            for (DailyTabulateDataEntity dailyTabulateDataEnt : dailyTabulateDataEntit) {
                System.out.println(dailyTabulateDataEnt.getId());
                SowRankTableEntity sowRankTableEntity = new SowRankTableEntity();
                sowRankTableEntity.setFarmCode(dailyTabulateDataEnt.getFarmCode());
                a++;
                sowRankTableEntity.setRank(String.valueOf(a));
                sowRankTableEntity.setSowLivestock(dailyTabulateDataEnt.getSowStock());//总存栏量
                sowRankTableEntity.setOutStockCount(1);
                //if(data.getTime().after(startTime)&data.getTime().before(DateUtilsPublic.addDateHour(startTime,1))){
            }
        }
    }
}




//如果数据不为空，说明已经存在----就只能更新而不是*----


        /*else if(          ){//如果不为空--那么就判断时间是否合适--这里为刷新时间1.如果日不相同，，刷新

        }
            Date date1 = new Date();
            //当前时间大于上一次时间四小时就更新----过零点自动刷新后面加上就可以
            Boolean timeGaptrue  = date1.after(sowRankTableEntity1.getCreate_time())   ;
            if (sowRankTableEntity1||    )
            System.out.println(dailyTabulateDataEnt.getId());

            SowRankTableEntity sowRankTableEntity = new SowRankTableEntity();
            sowRankTableEntity.setFarmCode(dailyTabulateDataEnt.getFarmCode());
             a++;
            sowRankTableEntity.setRank( String.valueOf(a));
            sowRankTableEntity.setSowLivestock(dailyTabulateDataEnt.getSowStock() );//总存栏量
            sowRankTableEntity.setOutStockCount(1);
        }



       //当日母猪总存栏是总数

*/